#ifndef __RANDOM
#define __RANDOM

#include <iostream>
using namespace std;

class Random{
public:
  Random(int i = 1){ init(i); }
  ~Random(){}
  int init(int i){ seed = (i)? i : 1; return i; }
  int operator () (int min, int max){
    long int hi = seed / q;
    long int lo = seed % q;
    long int temp = a * lo - r * hi;
    if (temp > 0) seed = temp;
    else seed = temp + m;
    return (int)(min + seed % (max-min+1));
  }
private:
  enum { a = 48271, m = 2147483647, q  = m/a, r = m%a };
  long int seed;
};
#endif
